Imports System.Messaging
Public Class Form1
    Private Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Integer, ByVal hWnd2 As Integer, ByVal lpsz1 As String, ByVal lpsz2 As String) As Integer

    Public Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hWnd As IntPtr, ByVal Msg As Integer, ByVal ByValByValwParam As Integer, ByVal lParam As String) As Integer

    Public Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

    Const WM_SETTEXT = &HC
    Const WM_GETTEXT = &HD
    Const WM_GETTEXTLENGTH = &HE
    Const WM_USER = &H400
    Const VK_SPACE = &H20
    Const WM_KEYDOWN = &H100
    Const EM_GETSELTEXT = (WM_USER + 62)
    Const WM_KEYUP = &H101
    Dim pr_handle As Long

    Dim message_old As String = ""


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Label2.ForeColor = Color.Blue
        Me.Label2.Text = "Nessun processo."

    End Sub
    Private Function SendMessage()
        Dim ihWnd As Long = 0
        Dim ihEdit As Long = 0
        Dim phEdit As IntPtr = Nothing
        Dim iRet As Integer
        Dim button As Long = 0
        Dim button_ptr As IntPtr = Nothing

        If pr_handle > 0 Then
            ihEdit = FindWindowEx(pr_handle, 0, "RichEdit20A", vbNullString)
            ihEdit = FindWindowEx(pr_handle, ihEdit, "RichEdit20A", vbNullString)
            phEdit = New IntPtr(ihEdit)
            iRet = SendMessage(phEdit, WM_SETTEXT, 0, "Hello")


            button = FindWindowEx(pr_handle, 0&, "button", vbNullString)
            button_ptr = New IntPtr(button)
            iRet = SendMessage(button_ptr, WM_KEYDOWN, VK_SPACE, 0)
            iRet = SendMessage(button_ptr, WM_KEYUP, VK_SPACE, 0)

        End If
    End Function
    Private Function GetMessage()
        Dim length As Long = 0
        Dim strtmp As String = ""
        Dim result As Long = 0
        Dim ihEdit As Long = 0
        Dim phEdit As IntPtr = Nothing
        Dim iRet As Integer
        Dim strtmp2 As String = ""
        'Me.RichTextBox1.Clear()

        If pr_handle > 0 Then
            ihEdit = FindWindowEx(pr_handle, 0, "RichEdit20A", vbNullString)

            phEdit = New IntPtr(ihEdit)

            length = SendMessage(ihEdit, WM_GETTEXTLENGTH, 0, 0) + 1
            strtmp = Space(length - 1)
            result = SendMessage(ihEdit, WM_GETTEXT, length, strtmp)




            'strtmp2 = strtmp
            'If strtmp <> message_old Then
            '    Try
            '        strtmp = strtmp.Remove(0, message_old.Length)
            '        Me.RichTextBox1.AppendText(strtmp)
            '        interpreta(strtmp)

            '    Catch ex As Exception
            '        MsgBox(ex.Message.ToString)
            '        Exit Function

            '    End Try
            'End If

            Dim interpreta_b As Boolean = False


            If message_old.Length < strtmp.Length Then
                Try
                    strtmp = strtmp.Remove(0, message_old.Length)
                    Me.RichTextBox1.AppendText(strtmp)
                    If interpreta_b Then interpreta(strtmp)

                Catch ex As Exception
                    MsgBox(ex.Message.ToString)
                    Exit Function

                End Try
            End If


            message_old = strtmp2



        End If






    End Function
    
    




    Private Sub interpreta(ByVal str As String)
        If str.Contains("divina") Then






            Dim ihWnd As Long = 0
            Dim ihEdit As Long = 0
            Dim phEdit As IntPtr = Nothing
            Dim iRet As Integer
            Dim button As Long = 0
            Dim button_ptr As IntPtr = Nothing

            If pr_handle > 0 Then
                ihEdit = FindWindowEx(pr_handle, 0, "RichEdit20A", vbNullString)
                ihEdit = FindWindowEx(pr_handle, ihEdit, "RichEdit20A", vbNullString)
                phEdit = New IntPtr(ihEdit)
                iRet = SendMessage(phEdit, WM_SETTEXT, 0, "Nel mezzo del cammin di nostra vita mi ritrovai per una selva oscura ch la diritta via era smarrita.")


                button = FindWindowEx(pr_handle, 0&, "button", vbNullString)
                button_ptr = New IntPtr(button)
                iRet = SendMessage(button_ptr, WM_KEYDOWN, VK_SPACE, 0)
                iRet = SendMessage(button_ptr, WM_KEYUP, VK_SPACE, 0)

            End If
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        SendMessage()
    End Sub
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        process_view()
    End Sub
    Private Sub process_view()
        Dim p As Process()
        p = Process.GetProcesses()
        start_datagrid()
        Dim row_index As Integer = 0
        Dim pr1 As Process
        For Each pr1 In p
            Me.DataGridView1.Rows.Add()
            Me.DataGridView1.Rows.Item(row_index).Cells(0).Value = pr1.Id.ToString
            Try
                Me.DataGridView1.Rows.Item(row_index).Cells(1).Value = pr1.Handle.ToString
            Catch ex As Exception
                Me.DataGridView1.Rows.Item(row_index).Cells(1).Value = "Errore: " & ex.Message.ToString
            End Try
            Me.DataGridView1.Rows.Item(row_index).Cells(2).Value = pr1.MainWindowHandle
            Me.DataGridView1.Rows.Item(row_index).Cells(3).Value = pr1.ProcessName
            Me.DataGridView1.Rows.Item(row_index).Cells(4).Value = pr1.MainWindowTitle
            row_index += 1
        Next
    End Sub


    Private Sub start_datagrid()
        Me.DataGridView1.Rows.Clear()
        Me.DataGridView1.Columns.Clear()
        Me.DataGridView1.Columns.Add("ID", "Id")
        Me.DataGridView1.Columns.Add("HANDLE", "Handle")
        Me.DataGridView1.Columns.Add("MAINWINDOWHANDLE", "Main Windows Handle")
        Me.DataGridView1.Columns.Add("NAME", "Nome")
        Me.DataGridView1.Columns.Add("MAINWINDOW", "MainWindow")
    End Sub

    Private Sub DataGridView1_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridView1.CellContentClick

        Dim index_col As Integer = e.ColumnIndex
        Dim index_row As Integer = e.RowIndex
        Dim dato As String = ""
        dato = Me.DataGridView1.Item(index_col, index_row).Value.ToString
        MsgBox("Selezionato: " & dato)
        If IsNumeric(dato) Then
            pr_handle = dato
            Me.Label2.ForeColor = Color.Red
            Me.Label2.Text = dato
        End If
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        GetMessage()
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click

        If pr_handle > 0 Then
            If Me.Timer1.Enabled = True Then
                Me.Timer1.Stop()
                Me.Button4.Text = "Start Logging"
            Else
                Me.Timer1.Start()
                Me.Button4.Text = "Logging"
            End If
        Else
            MsgBox("Processo non selezionato")
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        GetMessage()

    End Sub

    
    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click

    End Sub
End Class
